/**
 * @author Parfeniuk Bogdan
 *
 * @section LICENSE
 *
 *2016 ARM
 *
 */

/**
 * Includes
 */
#include "LCD.h"




void CONFIG_LCD_PINS(void)
{


	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);

	/* Configure GPIOs to drive LCD: */
	LCDIO_Setup.GPIO_Pin    = LCD_PINS;
	LCDIO_Setup.GPIO_Mode   = GPIO_Mode_Out_PP;
	LCDIO_Setup.GPIO_Speed  = GPIO_Speed_50MHz;
	GPIO_Init(LCD_IOP, &LCDIO_Setup);

	LCDCTR_Setup.GPIO_Pin	= LCD_CONT;
	LCDCTR_Setup.GPIO_Mode	= GPIO_Mode_Out_PP;
	LCDCTR_Setup.GPIO_Speed	= GPIO_Speed_50MHz;
	GPIO_Init(LCD_CTP, &LCDCTR_Setup);

	GPIO_ResetBits(LCD_CTP, LCD_CONT);
	GPIO_ResetBits(LCD_IOP, LCD_PINS);
}

void pushData(unsigned int data)
{
		LCD_IOP->ODR = data;
}
void delay(unsigned long ms)// delay 1 ms per count @ Crystal 8.0 MHz and PLL9x or SYSCLK = 72 MHz
{
    volatile unsigned long i,j;
    for (i = 0; i < ms; i++ )
    for (j = 0; j < 5525; j++ );
}


void sendCommand(unsigned int index)
{
    CS_LOW;
    RS_LOW;




    pushData(index>>8);
    WR_LOW;
    WR_HIGH;

   pushData(index);
  WR_LOW;
    WR_HIGH;

    CS_HIGH;
}

void sendData(unsigned int data)
{
    CS_LOW;
    RS_HIGH;


pushData(data>>8);
WR_LOW;
    WR_HIGH;


    pushData(data);
      WR_LOW;
    WR_HIGH;

    CS_HIGH;
}

void init (void)
{
RS_LOW;
 CS_LOW;
 WR_LOW;
 REST_LOW;

delay(10);
CS_HIGH;
WR_HIGH;
RS_HIGH;
REST_HIGH;

delay(15);

          sendCommand(0xE5); sendData(0x78F0); // set SRAM internal timing
          sendCommand(0x01); sendData(0x0100); // set SS and SM bit
          sendCommand(0x02); sendData(0x0700); // set 1 line inversion
        //	TFT_WR_CMD_DATA(0x0003, 0x1030);	//  
          sendCommand(0x03); sendData(0x1018); //  
          sendCommand(0x04); sendData(0x0000);
          sendCommand(0x08); sendData(0x0207);
          sendCommand(0x09); sendData(0x0000);

          sendCommand(0x0A); sendData(0x0000);
          sendCommand(0x0C); sendData(0x0000);//0001) 16-bit RGB interface (1 transfer/pixel), using internal system clock
          sendCommand(0x0D); sendData(0x0000);
          sendCommand(0x0F); sendData(0x0000);
//*************Power On sequence ****************//
          sendCommand(0x10); sendData(0x0000);
          sendCommand(0x11); sendData(0x0007);
          sendCommand(0x12); sendData(0x0000);
          sendCommand(0x13); sendData(0x0000);
          sendCommand(0x07); sendData(0x0001);

          // delay(200,ms);
         delay(200); // Dis-charge capacitor power voltage

          sendCommand(0x10); sendData(0x1090); //1690
          sendCommand(0x11); sendData(0x0227);
          delay(50);// Delay 50ms
            sendCommand(0x12); sendData(0x001F);////////!!!!!!!!(009D) (0f,0d,12)
          delay(50);
          sendCommand(0x13); sendData(0x1200); //(1900)
          sendCommand(0x29); sendData(0x0025); //(0027)
          sendCommand(0x2B); sendData(0x000E); // ??Hz frame rate, internal resistor.
          delay(50);
          sendCommand(0x20); sendData(0x0000);
          sendCommand(0x21); sendData(0x0000);
// ----------- Adjust the Gamma Curve ----------//
          sendCommand(0x30); sendData(0x0000);
          sendCommand(0x31); sendData(0x0707);
          sendCommand(0x32); sendData(0x0307);
          sendCommand(0x35); sendData(0x0200);
          sendCommand(0x36); sendData(0x0008);
          sendCommand(0x37); sendData(0x0004);
          sendCommand(0x38); sendData(0x0000);
          sendCommand(0x39); sendData(0x0707);

          sendCommand(0x3C); sendData(0x0002);//?? 0504
          sendCommand(0x3D); sendData(0x1D04);//?? 0808
 //------------------ Set GRAM area ---------------//
          sendCommand(0x50); sendData(0x0000);
          sendCommand(0x51); sendData(0x00EF);
          sendCommand(0x52); sendData(0x0000);
          sendCommand(0x53); sendData(0x013F);
          sendCommand(0x60); sendData(0xA700);
          sendCommand(0x61); sendData(0x0001);
          sendCommand(0x6A); sendData(0x0000);

          sendCommand(0x80); sendData(0x0000);
          sendCommand(0x81); sendData(0x0000);
          sendCommand(0x82); sendData(0x0000);
          sendCommand(0x83); sendData(0x0000);
          sendCommand(0x84); sendData(0x0000);
          sendCommand(0x85); sendData(0x0000);

          sendCommand(0x90); sendData(0x0310); //(0010)- dont work
          sendCommand(0x92); sendData(0x0600);
          sendCommand(0x07); sendData(0x013B);  // 262K color and display ON

}
void LCD_WriteReg(unsigned int INDEX, unsigned int DATA)
{
      sendCommand(INDEX);
      sendData(DATA);
}




void setOrientation(unsigned int HV)//horizontal or vertical
{
    sendCommand(0x03);
    if(HV==1)//vertical
    {
          sendData(0x1018);

    }
    else//horizontal
    {
          sendData(0x1030);
    }
    sendCommand(0x0022); //Start to write to display RAM
}
void TFT_set_cursor(unsigned int x_pos, unsigned int y_pos)
{
    unsigned int temp = 0x0000;

    #if (DISP_ORIENTATION == 0)

    #elif (DISP_ORIENTATION == 90)
    {
        temp = x_pos;
        x_pos = y_pos;
        y_pos = (MAX_X - temp - 1);
    }
    #elif (DISP_ORIENTATION == 180)
    {
        x_pos = (MAX_X - x_pos - 1);
        y_pos = (MAX_Y - y_pos - 1);
    }
    #elif (DISP_ORIENTATION == 270)
    {
        temp = y_pos;
        y_pos = x_pos;
        x_pos = (MAX_Y - temp - 1);
    }
    #endif

    LCD_WriteReg(0x0020, x_pos);
    LCD_WriteReg(0x0021, y_pos);
    sendCommand(0x0022);//Start to write to display RAM
}
void TFT_set_display_window(unsigned int x_pos, unsigned int y_pos, unsigned int w, unsigned int h)
{
    LCD_WriteReg(0x0050, x_pos);
    LCD_WriteReg(0x0051, (w + x_pos));
    LCD_WriteReg(0x0052, y_pos);
    LCD_WriteReg(0x0053, (h + y_pos));
    LCD_WriteReg(x_pos, y_pos);
}


void setPixel(unsigned int poX, unsigned int poY,unsigned int color)
{

    TFT_set_cursor(poX,poY);
    sendData(color);

}

void drawCircle(int poX, int poY, int r,unsigned int color)
{
    int x = -r, y = 0, err = 2-2*r, e2;
    do {
        setPixel(poX-x, poY+y,color);
        setPixel(poX+x, poY+y,color);
        setPixel(poX+x, poY-y,color);
        setPixel(poX-x, poY-y,color);
        e2 = err;
        if (e2 <= y) {
            err += ++y*2+1;
            if (-x == y && e2 <= x) e2 = 0;
        }
        if (e2 > x) err += ++x*2+1;
    }
    while (x <= 0);
}

void fillCircle(int poX, int poY, int r,unsigned int color)
{
    int x = -r, y = 0, err = 2-2*r, e2;
    do {

        drawVerticalLine(poX-x,poY-y,2*y,color);
        drawVerticalLine(poX+x,poY-y,2*y,color);

        e2 = err;
        if (e2 <= y) {
            err += ++y*2+1;
            if (-x == y && e2 <= x) e2 = 0;
        }
        if (e2 > x) err += ++x*2+1;
    }
    while (x <= 0);

}


void drawLine(unsigned int x0,unsigned int y0,unsigned int x1,unsigned int y1,unsigned int color)
{
    int dx = (x1-x0), sx = x0<x1 ? 1 : -1;
    int dy = -(y1-y0), sy = y0<y1 ? 1 : -1;
    int err = dx+dy, e2; // error value e_xy
    for (;;){ // loop
        setPixel(x0,y0,color);
        e2 = 2*err;
        if (e2 >= dy) { // e_xy+e_x > 0
            if (x0 == x1) break;
            err += dy;
            x0 += sx;
        }
        if (e2 <= dx) { // e_xy+e_y < 0
            if (y0 == y1) break;
            err += dx;
            y0 += sy;
        }
    }
}


void drawVerticalLine(unsigned int poX, unsigned int poY,unsigned int length,unsigned int color)
{
	unsigned int i;
	if(poX <0)
		poX = 0;
	if(poX>239)
		poX = 239;

	if(poY <0)
		poY = 0;
	if(poY>319)
		poY = 319;
    //poX = constrain(poX,MIN_X,MAX_X); //Limits the pixel range to 0 - 239
    //poY = constrain(poY,MIN_Y,MAX_Y); //Limits the pixel range to 0 - 319

    TFT_set_cursor(poX,poY);
    //setOrientation(0);
    if(length+poY>MAX_Y)
    {
        length=MAX_Y-poY;
    }

    for(i=0;i<length;i++)
    {
        sendData(color);
    }
}

void  drawHorizontalLine(unsigned int poX, unsigned int poY,unsigned int length,unsigned int color)
{
	unsigned int i;
	if(poX <0)
		poX = 0;
	if(poX>239)
		poX = 239;

	if(poY <0)
		poY = 0;
	if(poY>319)
		poY = 319;
    //poX = constrain(poX,MIN_X,MAX_X); //Limits the pixel range to 0 - 239
    //poY = constrain(poY,MIN_Y,MAX_Y); //Limits the pixel range to 0 - 319

    TFT_set_cursor(poX,poY);
    //setOrientation(0);
    if(length+poX>MAX_X)
    {
        length=MAX_X-poX;
    }
    for(i=0;i<length;i++)
    {
        sendData(color);
    }

}


void drawRectangle(unsigned int poX, unsigned int poY, unsigned int length,unsigned int width,unsigned int color)
{
    drawHorizontalLine(poX, poY, length, color);
    drawHorizontalLine(poX, poY+width, length, color);

    drawVerticalLine(poX, poY, width,color);
    drawVerticalLine(poX + length, poY, width,color);
}

void fillRectangle(unsigned int poX, unsigned int poY, unsigned int length, unsigned int width, unsigned int color)
{
	unsigned int i;
    for(i=0;i<width;i++)
    {
        drawHorizontalLine(poX, poY+i, length, color);
    }
}

void drawChar(unsigned char ascii,unsigned int poX, unsigned int poY,unsigned int size, unsigned int fgcolor)
{
	unsigned char i;
	unsigned char temp;
	unsigned char f;
    TFT_set_cursor(poX,poY);
    //setOrientation(1);
    if((ascii < 0x20)||(ascii > 0x7e))//Unsupported char.
    {
        ascii = '?';
    }
    for(i=0;i<8;i++)
    {
        temp = simpleFont[ascii-0x20][i];
        for(f=0;f<8;f++)
        {
            if((temp>>f)&0x01)
            {
                fillRectangle(poX+i*size, poY+f*size, size, size, fgcolor);
            }

        }
    }
}

void drawString(char *string,unsigned int poX, unsigned int poY,unsigned int size,unsigned int fgcolor)
{
    while(*string)
    {
         drawChar(*string, poX, poY, size, fgcolor);
         string++;

        if(poX < MAX_X)
        {
            poX+=8*size; // Move cursor right
        }
    }
}

unsigned char drawNumber(long long_num,unsigned int poX, unsigned int poY,unsigned int size,unsigned int fgcolor)
{
  unsigned char char_buffer[10]="";
  unsigned char i = 0;
  unsigned char f = 0;

  if (long_num < 0)
  {
    f=1;
    drawChar('-',poX, poY, size, fgcolor);
    long_num = -long_num;
    if(poX < MAX_X)
    {
        poX+=8*size; // Move cursor right
    }
  }
  else if (long_num == 0)
  {
    f=1;
    drawChar('0',poX, poY, size, fgcolor);
    return f;
    if(poX < MAX_X)
    {
        poX+=8*size; // Move cursor right
    }
  }


  while (long_num > 0)
  {
    char_buffer[i++] = long_num % 10;
    long_num /= 10;
  }

  f=f+i;
  for(; i > 0; i--)
  {
    drawChar('0'+ char_buffer[i - 1],poX, poY, size, fgcolor);
    if(poX < MAX_X)
    {
        poX+=8*size; // Move cursor right
    }
  }
  return f;
}

unsigned char drawFloat(float floatNumber,unsigned char decimal,unsigned int poX, unsigned int poY,unsigned int size,unsigned int fgcolor)
{
  unsigned int temp=0;
  float decy=0.0;
  float rounding = 0.5;
  unsigned char f=0;
  unsigned char i;
  unsigned char howlong;

  if(floatNumber<0.0)
  {
    drawChar('-',poX, poY, size, fgcolor);
    floatNumber = -floatNumber;
    if(poX < MAX_X)
    {
        poX+=8*size; // Move cursor right
    }
    f =1;
  }
  for (i=0; i<decimal; ++i)
  {
    rounding /= 10.0;
  }
  floatNumber += rounding;

  temp = (unsigned int)floatNumber;
  howlong=drawNumber(temp,poX, poY, size, fgcolor);
  f += howlong;
  if((poX+8*size*howlong) < MAX_X)
    {
        poX+=8*size*howlong; // Move cursor right
    }

  if(decimal>0)
  {
    drawChar('.',poX, poY, size, fgcolor);
    if(poX < MAX_X)
    {
        poX+=8*size; // Move cursor right
    }
    f +=1;
 }
  decy = floatNumber-temp;//decimal part,
  for(i=0;i<decimal;i++)//4
  {
    decy *=10;// for the next decimal
    temp = decy;//get the decimal
    drawNumber(temp,poX, poY, size, fgcolor);
    floatNumber = -floatNumber;
    if(poX < MAX_X)
    {
        poX+=8*size; // Move cursor right
    }
    decy -= temp;
  }
  f +=decimal;
  return (unsigned char)f;
}
void Draw_BMP(unsigned int x_pos, unsigned int y_pos, unsigned int H, unsigned int W, unsigned char *bitmap)
{
     unsigned long index = 0;
     unsigned long size = (W * H);
     unsigned int *bitmap_ptr = (unsigned int*)bitmap;

     TFT_set_display_window(x_pos, y_pos, (W - 1), (H - 1));
     sendCommand(0x0022); //Start to write to display RAM

     for(index = 0; index < size; index++)
     {
         sendData(*bitmap_ptr++);
     }


}

